'''
nose unit tests for CFchecker.cf13
'''
import os

from CFchecker.cf13 import CF13Tests
import cf12_test
import helpers

class CF13Tests_test(cf12_test.CF12Tests_test):
    '''
    test 3.5 changed, so a new test has to be written for it
    '''
    test_class = CF13Tests

    @classmethod
    def setup_class(cls):
        cf12_test.CF12Tests_test.setup_class()
        helpers.amend_faulty_ncfile_cf13(os.path.join(cls.tempdir, cls.faulty_file))
        helpers.amend_good_ncfile_cf13(os.path.join(cls.tempdir, cls.good_file))


    def test_3_5_check(self):
        '''CF13Tests: test 3.5'''
        msgs = { self.faulty_file: [('ERROR', '3.5', 'casetest: flag_values attribute and variable need to have the same data type ' \
                                                     '(S <-> f)'),
                                    ('WARNING', '3.5', 'casetest: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', 'casetest: flag_meanings attribute should be a string'),
                                    ('ERROR', '3.5', 'CaseTest: flag_values and flag_meanings attributes have different lengths (3 <-> 7)'),
                                    ('ERROR', '3.5', 'CaseTest: flag_masks and flag_meanings attributes have different lengths (4 <-> 7)'),
                                    ('ERROR', '3.5', 'CaseTest: flag_masks attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('WARNING', '3.5', 'CaseTest: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', 'CaseTest: variable type must be compatible with bit field expressions (char, short, int, long)'),
                                    ('ERROR', '3.5', 'wrong_dim_order: flag_meanings attribute without flag_values or flag_masks attribute'),
                                    ('WARNING', '3.5', 'wrong_dim_order: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', 'double_dependency: flag_values attribute and variable need to have the same data ' \
                                                     'type (S <-> f)'),
                                    ('WARNING', '3.5', 'double_dependency: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', '_spam_data: flag_values attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute and variable need to have the same data type ' \
                                                     '(i <-> f)'),
                                    ('ERROR', '3.5', '_spam_data: flag_values attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', '_spam_data: variable type must be compatible with bit field expressions '
                                                     '(char, short, int, long)'),
                                    ('WARNING', '3.5', '_spam_data: flag_* attributes found but status_flag modifier not set'),
                                    ('ERROR', '3.5', '_spam_data: flag_masks attribute values must be non-zero'),
                                    ('WARNING', '3.5', '_spam_data: boolean AND of flag_values and flag_masks entries should equal flag_values entry'),
                                    ('ERROR', '3.5', 'double_dependency: flag_values and flag_meanings attributes have '
                                                     'different lengths (45 <-> 4)'),
                                    ('ERROR', '3.5', 'double_dependency: every flag_values value has to be unique within the set of all '
                                                     'flag_values'),
                                    ('ERROR', '3.5', 'casetest: every flag_values value has to be unique within the set of all '
                                                     'flag_values'),
                                    ('WARNING', '3.5', 'double_axis: boolean AND of flag_values and flag_masks entries should equal flag_values entry'),
                                    ('ERROR', '3.5', 'double_axis: flag_values attribute without flag_meanings attribute'),
                                    ('ERROR', '3.5', 'double_axis: flag_masks attribute without flag_meanings attribute'),
                                    ('WARNING', '3.5', 'double_axis: flag_* attributes found but status_flag modifier not set'),
                                      ],
                 self.good_file: [],
                }
        self.check_runner(msgs)
